<?php

/*
 * hook views_default_views
 */

function repas_views_default_views() {
    $view = new view();
    $view->name = 'les_plats_de_l_utilisateur';
    $view->description = '';
    $view->tag = 'default';
    $view->base_table = 'node';
    $view->human_name = 'Les plats de l\'utilisateur';
    $view->core = 7;
    $view->api_version = '3.0';
    $view->disabled = FALSE; /* Edit this to true to make a default view disabled initially */

    /* Display: Master */
    $handler = $view->new_display('default', 'Master', 'default');
    $handler->display->display_options['title'] = 'Les plats de l\'utilisateur';
    $handler->display->display_options['use_more_always'] = FALSE;
    $handler->display->display_options['use_more_text'] = 'plus';
    $handler->display->display_options['access']['type'] = 'perm';
    $handler->display->display_options['cache']['type'] = 'none';
    $handler->display->display_options['query']['type'] = 'views_query';
    $handler->display->display_options['exposed_form']['type'] = 'basic';
    $handler->display->display_options['exposed_form']['options']['submit_button'] = 'Appliquer';
    $handler->display->display_options['exposed_form']['options']['reset_button_label'] = 'Réinitialiser';
    $handler->display->display_options['exposed_form']['options']['exposed_sorts_label'] = 'Trier par';
    $handler->display->display_options['pager']['type'] = 'some';
    $handler->display->display_options['pager']['options']['items_per_page'] = '5';
    $handler->display->display_options['style_plugin'] = 'default';
    $handler->display->display_options['row_plugin'] = 'fields';
    /* Relation: Contenu : Restaurant (field_restaurant) */
    $handler->display->display_options['relationships']['field_restaurant_nid']['id'] = 'field_restaurant_nid';
    $handler->display->display_options['relationships']['field_restaurant_nid']['table'] = 'field_data_field_restaurant';
    $handler->display->display_options['relationships']['field_restaurant_nid']['field'] = 'field_restaurant_nid';
    $handler->display->display_options['relationships']['field_restaurant_nid']['delta'] = '-1';
    /* Champ: Contenu : Titre */
    $handler->display->display_options['fields']['title']['id'] = 'title';
    $handler->display->display_options['fields']['title']['table'] = 'node';
    $handler->display->display_options['fields']['title']['field'] = 'title';
    $handler->display->display_options['fields']['title']['label'] = '';
    $handler->display->display_options['fields']['title']['alter']['word_boundary'] = FALSE;
    $handler->display->display_options['fields']['title']['alter']['ellipsis'] = FALSE;
    /* Champ: Contenu : Restaurant */
    $handler->display->display_options['fields']['field_restaurant']['id'] = 'field_restaurant';
    $handler->display->display_options['fields']['field_restaurant']['table'] = 'field_data_field_restaurant';
    $handler->display->display_options['fields']['field_restaurant']['field'] = 'field_restaurant';
    /* Champ: Contenu : Adresse */
    $handler->display->display_options['fields']['field_adresse']['id'] = 'field_adresse';
    $handler->display->display_options['fields']['field_adresse']['table'] = 'field_data_field_adresse';
    $handler->display->display_options['fields']['field_adresse']['field'] = 'field_adresse';
    /* Critère de tri: Contenu : Date de publication */
    $handler->display->display_options['sorts']['created']['id'] = 'created';
    $handler->display->display_options['sorts']['created']['table'] = 'node';
    $handler->display->display_options['sorts']['created']['field'] = 'created';
    $handler->display->display_options['sorts']['created']['order'] = 'DESC';
    /* Filtre contextuel: Contenu : uid de l'auteur */
    $handler->display->display_options['arguments']['uid']['id'] = 'uid';
    $handler->display->display_options['arguments']['uid']['table'] = 'node';
    $handler->display->display_options['arguments']['uid']['field'] = 'uid';
    $handler->display->display_options['arguments']['uid']['exception']['title'] = 'Tout';
    $handler->display->display_options['arguments']['uid']['default_argument_type'] = 'fixed';
    $handler->display->display_options['arguments']['uid']['summary']['format'] = 'default_summary';
    /* Critère de filtrage: Contenu : Publié */
    $handler->display->display_options['filters']['status']['id'] = 'status';
    $handler->display->display_options['filters']['status']['table'] = 'node';
    $handler->display->display_options['filters']['status']['field'] = 'status';
    $handler->display->display_options['filters']['status']['value'] = 1;
    $handler->display->display_options['filters']['status']['group'] = 1;
    $handler->display->display_options['filters']['status']['expose']['operator'] = FALSE;
    /* Critère de filtrage: Contenu : Type */
    $handler->display->display_options['filters']['type']['id'] = 'type';
    $handler->display->display_options['filters']['type']['table'] = 'node';
    $handler->display->display_options['filters']['type']['field'] = 'type';
    $handler->display->display_options['filters']['type']['value'] = array(
      'plat' => 'plat',
    );

    /* Display: Block */
    $handler = $view->new_display('block', 'Block', 'block');
    $translatables['les_plats_de_l_utilisateur'] = array(
      t('Master'),
      t('Les plats de l\'utilisateur'),
      t('plus'),
      t('Appliquer'),
      t('Réinitialiser'),
      t('Trier par'),
      t('Asc'),
      t('Desc'),
      t('field_restaurant'),
      t('Restaurant'),
      t('Adresse'),
      t('Tout'),
      t('Block'),
    );
    $views[$view->name] = $view;
    
    return $views;
}
?>
